#include <stdio.h>
#include "CBB022HIDSDK.h"

#pragma comment(lib, "CBB022HIDSDK.lib")

#define PID 0x2080 //v_NgID

void ReadProc(char *buf);
void WriteProc(char *buf);

int main(void)
{
	int count = 0;

	//CPU{[hƐڑ
	if (!CWRC_Connect(PID))
	{
		printf("Connect failed");
		//ڑ̏ꍇA100msɐڑ̊mFs
		while (1){
			if (count % 10 == 0)
				printf("%2s", " .");

			if (CWRC_Connect(PID)){
				printf("\n\nConnect");
				break;
			}
			else if (count++ >= 100){
				printf(" Connection timed out\n");
				Sleep(1500);
				return 0;
			}
			Sleep(100);
		}
	}
	else{
		printf("Connect");
	}

	while (1){
		char buf[256];
		printf("\n\n");
		printf("c : Connect\n");
		printf("d : Disconnect\n");
		printf("r [addr(Hex)] [length(Hex)]         :read\n");
		printf("w [type] [addr(Hex)] [value(Dec)]   :write\n");
		printf("     [type] = sb,sw,sl,ub,uw,ul\n");
		printf("f i : flash default value\n");
		printf("f m : flash Ram to Rom\n");
		printf("e : Exit\n");
		printf("\n>");

		fgets(buf, sizeof(buf), stdin);
		printf(">");

		switch (buf[0]){
		case 'C': case 'c':
			if (!CWRC_Connect(PID)){	//CPU{[hƂ̒ʐMJn
				printf("Connect failed\n");
			}
			else{
				printf("Connect\n");
			}
			break;
		case 'D': case 'd':
			CWRC_Disconnect();	//CPU{[hƂ̒ʐMؒf
			printf("Disconnected\n");
			break;

		case 'W': case 'w':
			WriteProc(buf);		//RAMփf[^
			break;

		case 'R': case 'r':
			ReadProc(buf);		//RAM̃f[^ǂݍ
			break;

		case 'F': case 'f':
		{
			switch (buf[2]){
			case 'm':
				CWRC_FlashExecute();		//RAM̃f[^FlashROM֏
				printf("map flash\n");
				printf("disconnect");
				break;
			case 'i':
				CWRC_InitializeExecute();	//FlashROM
				printf("map init\n");
				printf("disconnect\n");
				break;
			default:
				printf("error");
			}
		}
			break;

		case 'E': case 'e':		//AvP[V\tgI
		{
			if (buf[1] == '\n')
			{
				printf_s("EXIT\n\n");
				Sleep(1500);
				CWRC_Disconnect();
				return 0;
			}
		}
			break;
	}
		Sleep(100);

	}
	CWRC_Disconnect();

	return 0;
}

//GetMem_UByte֐sARAM̃f[^ǂݍ
void ReadProc(char *buf){
	int adr = -1, size = -1;
	char buf2[256];
	sscanf_s(buf, "%s %x %x", buf2, 2, &adr, &size);

	printf("adr = %d , size = %d\n", adr, size);

	if (adr >= 0 && size >= 0) {
		CWRC_ReadMemMap(adr, size);
		int rcvsize = CWRC_ReadExecute();
		if (rcvsize){
			for (int i = 0; i < size; i++){
				printf("%01x ", GetMem_UByte(adr + i));	//}bv̎wAhXAchar^̃f[^ǂݍ
			}
			printf("\n");
		}
		else{
			printf("error");
		}
	}
}

//SetMem_xxx֐sARAMփf[^
void WriteProc(char *buf){
	int adr = -1, data = -1;
	char buf2[256];
	char buf3[256];

	sscanf_s(buf, "%s %s %x %d", buf2, 2, buf3, 3, &adr, &data);
	if (adr >= 0) {

		switch (buf3[0]){
		case 'S':case 's':
			switch (buf3[1]){
			case 'B':case 'b':
				SetMem_SByte(adr, (char)data);	//}bv̎wAhXɁAchar^̃f[^
				printf("write sbyte\n");
				break;

			case 'W':case 'w':
				SetMem_SWord(adr, (short)data);	//}bv̎wAhXɁAshort^̃f[^
				printf("write sword\n");
				break;

			case 'L':case 'l':
				SetMem_SLong(adr, (long)data);	//}bv̎wAhXɁAlong^̃f[^
				printf("write slong\n");
				break;

			default:
				printf("error s\n");
				break;
			}
			break;
		case 'U':case 'u':
			switch (buf3[1]){
			case 'B':case 'b':
				SetMem_UByte(adr, (unsigned char)data);		//}bv̎wAhXɁAunsigned char^̃f[^
				printf("write ubyte\n");
				break;
			case 'W':case 'w':
				SetMem_UWord(adr, (unsigned short)data);	//}bv̎wAhXɁAunsigned short^̃f[^
				printf("write uword\n");
				break;
			case 'L':case 'l':
				SetMem_ULong(adr, (unsigned long)data);		//}bv̎wAhXɁAunsigned long^̃f[^
				printf("write ulong\n");
				break;
			default:
				printf("error u\n");
				break;
			}
			break;

		case 'D':case 'd':
		{
			double d = 0.0;
			sscanf_s(buf, "%s %s %x %lf", buf2, 10, buf3, 10, &adr, &d);
			SetMem_Double(adr, d);	//}bv̎wAhXɁAdouble^̃f[^
			printf("write double\n");
		}
			break;
		default:
			printf("error\n");
			break;

		}

		//RAMւ̏ݎs
		if (CWRC_WriteExecute() <= 0){
			printf("disconnect\n");
		}
	}
	else{
		printf("error\n");
	}
}
